############################################
##                                        ##
##          WebAdverts (Display)          ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##         last modified:  9/7/97         ##
##           copyright (c) 1997           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

# NOTHING BELOW THIS LINE NEEDS TO BE ALTERED!

sub ADVsetup {
	$ADVtime = time;
	($ADVmday,$ADVmon,$ADVyear) = (localtime($ADVtime))[3,4,5];
	if ($ADVmday < 10) { $ADVmday = "0$ADVmday"; }
	$ADVmon++;
	if ($ADVmon < 10) { $ADVmon = "0$ADVmon"; }
	$ADVyear = $ADVyear+1900;
	$ADVshown = 0;
	$ADVWrapCounter = 0;
	unless ($advertzone) { $advertzone = "unzoned"; }
	if ($ENV{'QUERY_STRING'} =~ /advert=([^\s]*)/) {
		$displayad = $1;
		&gotoad;
		return;
	}
	unless ($NonSSI || $ADVNoPrint) { print "Content-type: text/html\n\n"; }
	if ($ENV{'QUERY_STRING'} =~ /ID=([^\s]*)/) {
		$ADVID = $1;
		&CreditID;
	}
	else {
		if ($advertzone eq "ShowAll") { &ADVshowall; }
		else { &ADVdisplayad; }
	}
}

sub CreditID {
	$ADVlockerror = &ADVLockFile("$ADVID.txt");
	unless ($ADVlockerror) {
		open (ADVDISPLAY, "+<$adverts_dir/$ADVID.txt");
		@ADVdisplaylines = <ADVDISPLAY>;
		($ADVratio,$ADVdisplaycount) = split (/\|/, @ADVdisplaylines[16]);
		$ADVdisplaycount++;
		unless (@ADVdisplaylines < 1) {
			seek(ADVDISPLAY, 0, 0);
			foreach $key (0..15) {
				print ADVDISPLAY "@ADVdisplaylines[$key]";
			}
			print ADVDISPLAY "$ADVratio|$ADVdisplaycount\n";
			truncate (ADVDISPLAY, tell(ADVDISPLAY));
		}
		close (ADVDISPLAY);
		&ADVUnlockFile("$ADVID.txt");
	}
	$ADVlockerror = &ADVLockFile("$ADVID.log");
	unless ($ADVlockerror) {
		if (-e "$adverts_dir/$ADVID.log") {
			open (DAILYLOG,"+<$adverts_dir/$ADVID.log");
		}
		else {
			open (DAILYLOG,">$adverts_dir/$ADVID.log");
		}
		$ADVaccess = "$ADVmday $ADVmon $ADVyear S";
		$ADVlocation = tell DAILYLOG;
		while ($ADVline = <DAILYLOG>) {
			if (($ADVacc,$ADVlogstring) = ($ADVline =~
			  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d S)$/)) {
				if ($ADVaccess eq $ADVlogstring) {
					last;
				}
			}
			last if ($ADVaccess eq $ADVlogstring);
			$ADVlocation = tell DAILYLOG;
			$ADVacc = 0;
		}
		$ADVacc++;
		seek (DAILYLOG, $ADVlocation, 0);
		$ADVlongacc = sprintf("%010.10d",$ADVacc);
		print DAILYLOG "$ADVlongacc $ADVaccess\n";
		close (DAILYLOG);
		&ADVUnlockFile("$ADVID.log");
	}
	&ADVdisplayad;
}

sub ADVdisplayad {
	$ADVWrapCounter++;
	$ADVlockerror = &ADVLockFile("adcount.txt");
	if ($ADVlockerror) { return; }
	open (ADVCOUNT, "+<$adverts_dir/adcount.txt");
	@ADVcountlines = <ADVCOUNT>;
	if ((@ADVcountlines < 4)
	  || ($ADVWrapCounter > @ADVcountlines-3)) {
		close (ADVCOUNT);
		&ADVUnlockFile("adcount.txt");
		return;
	}
	foreach $ADVline (@ADVcountlines) {
		chop ($ADVline) if ($ADVline =~ /\n$/);
	}
	$ADVcount = $ADVcountlines[0];
	@ADVcount = split(/\|/,$ADVcount);
	foreach $ADVcount (@ADVcount) {
		($ADVone,$ADVtwo) = split(/=/,$ADVcount);
		unless ($ADVtwo) { $ADVtwo = "unzoned"; }
		$zonecount{$ADVtwo} = $ADVone;
	}
	unless ($zonecount{$advertzone}) { $zonecount{$advertzone} = 1; }
	$ADVexposures = $ADVcountlines[1];
	($ADVexposures,@ADVcycles) = split (/\|/, $ADVexposures);
	foreach $ADVcycles (@ADVcycles) {
		($ADVone,$ADVtwo) = split(/=/,$ADVcycles);
		unless ($ADVtwo) { $ADVtwo = "unzoned"; }
		$cyclecount{$ADVtwo} = $ADVone;
	}
	unless ($cyclecount{$advertzone}) { $cyclecount{$advertzone} = 1; }
	$ADVdisplayad = $ADVcountlines[$zonecount{$advertzone}+2];
	$ADVcycles = $cyclecount{$advertzone};
	$zonecount{$advertzone}++;
	if ($zonecount{$advertzone} > @ADVcountlines-3) {
		$zonecount{$advertzone} = 1;
		$cyclecount{$advertzone}++;
	}
	$ADVcountlines[0] = "";
	foreach $key (keys %zonecount) {
		$ADVcountlines[0] =
		  $ADVcountlines[0]."$zonecount{$key}=$key|";
	}
	if ($ADVID eq $ADVdisplayad) {
		&CloseCount;
		&ADVdisplayad;
		return;
	}
	$ADVlockerror = &ADVLockFile("$ADVdisplayad.txt");
	if ($ADVlockerror) {
		&CloseCount;
		&ADVdisplayad;
		return;
	}
	open (ADVDISPLAY, "+<$adverts_dir/$ADVdisplayad.txt");
	@ADVdisplaylines = <ADVDISPLAY>;
	foreach $ADVline (@ADVdisplaylines) {
		chop ($ADVline) if ($ADVline =~ /\n$/);
	}
	($ADVmax,$ADVshown,$ADVvisits,
	  $ADVurl,$ADVimage,$ADVheight,$ADVwidth,
	  $ADValt,$ADVpass,$ADVtext,$ADVstart,
	  $ADVweight,$ADVzone,$ADVborder,$ADVtarget,
	  $ADVraw,$ADVratio) = @ADVdisplaylines;
	($ADVmax,$ADVmaxtype) = split (/\|/, $ADVmax);
	unless ($ADVmaxtype) { $ADVmaxtype = "E"; }
	($ADVdisplayratio,$ADVdisplaycount) = split (/\|/, $ADVratio);
	$ADVrealmax = $ADVmax;
	if (($ADVmaxtype eq "E") && ($ADVdisplayratio > 0)) {
		$ADVrealmax += int($ADVdisplaycount/$ADVdisplayratio);
	}
	($ADVtext,$ADVtexttype) = split (/\|/, $ADVtext);
	unless ($ADVtexttype) { $ADVtexttype = "B"; }
	if ((($advertzone ne "unzoned") && ($advertzone ne "ShowAll")
	  && (length($ADVzone) > 2) && ($ADVzone !~ /\s$advertzone\s/))
	  || ($ADVweight < 1)
	  || (($ADVmaxtype eq "E") && ($ADVrealmax <= $ADVshown))
	  || (($ADVmaxtype eq "C") && ($ADVrealmax <= $ADVvisits))
	  || (($ADVmaxtype eq "D") && ($ADVrealmax <= $ADVtime))
	  || ((($ADVcycles/$ADVweight) != int($ADVcycles/$ADVweight))
	  && ($advertzone ne "ShowAll"))) {
		&CloseCount;
		close (ADVDISPLAY);
		&ADVUnlockFile("$ADVdisplayad.txt");
		&ADVdisplayad;
		return;
	}
	$ADVexposures++;
	&CloseCount;
	@ADVimage = split (/\|/,$ADVimage);
	$imagecount = @ADVimage;
	srand();
	$ADVdisplayimage = @ADVimage[int(rand($imagecount))];
	if ($NonSSI) {
		$ADVlockerror = &ADVLockFile("nonssi.log");
		if ($ADVlockerror) { return; }
		if (-e "$adverts_dir/nonssi.log") {
			open (NONSSILOG,"+<$adverts_dir/nonssi.log");
		}
		else {
			open (NONSSILOG,">$adverts_dir/nonssi.log");
		}
		@nonssi = <NONSSILOG>;
		seek(NONSSILOG, 0, 0);
		foreach $nonssiline (@nonssi) {
			($nonssitime,$other) = split(/\s/,$nonssiline);
			unless (($ADVtime-$nonssitime) > 3600) {
				print NONSSILOG "$nonssiline";
			}
		}
		$ADVremote = "NA";
		if ($ENV{'REMOTE_ADDR'}) {
			$ADVremote = $ENV{'REMOTE_ADDR'};
		}
		$ADVdoc = "NA";
		if ($ENV{'HTTP_REFERER'}) {
			$ADVdoc = $ENV{'HTTP_REFERER'};
		}
		$ADVagent = "NA";
		if ($ENV{'HTTP_USER_AGENT'}) {
			$ADVagent = $ENV{'HTTP_USER_AGENT'};
		}
		$ADVagent =~ s/[^\w_-]//g;
		print NONSSILOG "$ADVtime $ADVremote $ADVdoc ";
		print NONSSILOG "$ADVagent $advertzone | $ADVdisplayad\n";
		truncate (NONSSILOG, tell(NONSSILOG));
		close (NONSSILOG);
		&ADVUnlockFile("nonssi.log");
		print "Location: $ADVdisplayimage\n\n";
	}
	elsif ($ADVraw) {
		print "$ADVraw\n";
	}
	else {
		print "<P ALIGN=CENTER>";
		if ($ADVtext && ($ADVtexttype eq "T")
		  && ($advertzone ne "ShowAll")) {
			print "<SMALL>";
			if ($ADVurl) {
				print "<A HREF=\"$display_cgi?";
				print "advert=$ADVdisplayad\"";
				if ($ADVtarget eq "_top") {
					print " TARGET=\"$ADVtarget\"";
				}
				elsif ($ADVtarget) {
					print " $ADVtarget";
				}
				print ">";
			}
			print "$ADVtext";
			if ($ADVurl) {
				print "</A>";
			}
			print "</SMALL><BR>";
		}
		if ($ADVurl) {
			print "<A HREF=\"$display_cgi?advert=$ADVdisplayad\"";
			if ($ADVtarget eq "_top") {
				print " TARGET=\"$ADVtarget\"";
			}
			elsif ($ADVtarget) {
				print " $ADVtarget";
			}
			print ">";
		}
		print "<IMG SRC=\"$ADVdisplayimage\"";
		if ($ADVheight && $ADVwidth) {
			print " HEIGHT=$ADVheight WIDTH=$ADVwidth";
		}
		print " ALT=\"$ADValt\"";
		unless ($ADVborder) { $ADVborder="0"; }
		print " BORDER=$ADVborder";
		print ">";
		if ($ADVurl) {
			print "</A>";
		}
		if ($ADVtext && ($ADVtexttype eq "B")
		  && ($advertzone ne "ShowAll")) {
			print "<BR><SMALL>";
			if ($ADVurl) {
				print "<A HREF=\"$display_cgi?";
				print "advert=$ADVdisplayad\"";
				if ($ADVtarget eq "_top") {
					print " TARGET=\"$ADVtarget\"";
				}
				elsif ($ADVtarget) {
					print " $ADVtarget";
				}
				print ">";
			}
			print "$ADVtext";
			if ($ADVurl) {
				print "</A>";
			}
			print "</SMALL>";
		}
		print "</P>\n";
	}
	$ADVshown += 1;
	if ($ADVmax || $ADVratio) {
		seek(ADVDISPLAY, 0, 0);
		print ADVDISPLAY "$ADVmax|$ADVmaxtype\n";
		print ADVDISPLAY "$ADVshown\n";
		print ADVDISPLAY "$ADVvisits\n";
		print ADVDISPLAY "$ADVurl\n";
		print ADVDISPLAY "$ADVimage\n";
		print ADVDISPLAY "$ADVheight\n";
		print ADVDISPLAY "$ADVwidth\n";
		print ADVDISPLAY "$ADValt\n";
		print ADVDISPLAY "$ADVpass\n";
		print ADVDISPLAY "$ADVtext|$ADVtexttype\n";
		print ADVDISPLAY "$ADVstart\n";
		print ADVDISPLAY "$ADVweight\n";
		print ADVDISPLAY "$ADVzone\n";
		print ADVDISPLAY "$ADVborder\n";
		print ADVDISPLAY "$ADVtarget\n";
		print ADVDISPLAY "$ADVraw\n";
		print ADVDISPLAY "$ADVratio\n";
		truncate (ADVDISPLAY, tell(ADVDISPLAY));
	}
	close (ADVDISPLAY);
	&ADVUnlockFile("$ADVdisplayad.txt");
	$ADVlockerror = &ADVLockFile("$ADVdisplayad.log");
	if ($ADVlockerror) { return; }
	if (-e "$adverts_dir/$ADVdisplayad.log") {
		open (DAILYLOG,"+<$adverts_dir/$ADVdisplayad.log");
	}
	else {
		open (DAILYLOG,">$adverts_dir/$ADVdisplayad.log");
	}
	$ADVaccess = "$ADVmday $ADVmon $ADVyear E";
	$ADVlocation = tell DAILYLOG;
	while ($ADVline = <DAILYLOG>) {
		if (($ADVacc,$ADVlogstring) = ($ADVline =~
		  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d E)$/)) {
			if ($ADVaccess eq $ADVlogstring) {
				last;
			}
		}
		last if ($ADVaccess eq $ADVlogstring);
		$ADVlocation = tell DAILYLOG;
		$ADVacc = 0;
	}
	$ADVacc++;
	seek (DAILYLOG, $ADVlocation, 0);
	$ADVlongacc = sprintf("%010.10d",$ADVacc);
	print DAILYLOG "$ADVlongacc $ADVaccess\n";
	close (DAILYLOG);
	&ADVUnlockFile("$ADVdisplayad.log");
}

sub CloseCount {
	$ADVcountlines[1] = "$ADVexposures|";
	foreach $key (keys %cyclecount) {
		$ADVcountlines[1] =
		  $ADVcountlines[1]."$cyclecount{$key}=$key|";
	}
	unless (@ADVcountlines < 1) {
		seek(ADVCOUNT, 0, 0);
		foreach $ADVline (@ADVcountlines) {
			unless (length($ADVline) < 1) {
				print ADVCOUNT "$ADVline\n";
			}
		}
		truncate (ADVCOUNT, tell(ADVCOUNT));
	}
	close (ADVCOUNT);
	&ADVUnlockFile("adcount.txt");
}

sub ADVshowall {
	$ADVshown = 0;
	&ADVdisplayad;
	unless ((@ADVcountlines < 4)
	  || ($ADVWrapCounter > @ADVcountlines-3)) {
		&ADVshowall
	}
}

sub gotoad {
	if ($displayad eq "NonSSI") {
		$ADVlockerror = &ADVLockFile("nonssi.log");
		if ($ADVlockerror) {
			undef (@nonssi);
		}
		else {
			open (NONSSILOG,"<$adverts_dir/nonssi.log");
			@nonssi = <NONSSILOG>;
			close (NONSSILOG);
			&ADVUnlockFile("nonssi.log");
		}
		@reversenonssi = reverse (@nonssi);
		$ADVremote = "NA";
		if ($ENV{'REMOTE_ADDR'}) {
			$ADVremote = $ENV{'REMOTE_ADDR'};
		}
		$ADVdoc = "NA";
		if ($ENV{'HTTP_REFERER'}) {
			$ADVdoc = $ENV{'HTTP_REFERER'};
		}
		$ADVagent = "NA";
		if ($ENV{'HTTP_USER_AGENT'}) {
			$ADVagent = $ENV{'HTTP_USER_AGENT'};
		}
		$ADVagent =~ s/[^\w_-]//g;
		$logcheck = "$ADVremote $ADVdoc $ADVagent $advertzone";
		foreach $nonssiline (@reversenonssi) {
			if ($nonssiline =~ /^\d* $logcheck \| (.*)$/) {
				$displayad = $1;
				last;
			}
		}
		if ($displayad eq "NonSSI") {
			&BadRef;
			return;
		}
	}
	$ADVlockerror = &ADVLockFile("$displayad.txt");
	if ($ADVlockerror) {
		&BadRef;
		return;
	}
	open (ADVDISPLAY, "+<$adverts_dir/$displayad.txt");
	@ADVdisplaylines = <ADVDISPLAY>;
	foreach $ADVline (@ADVdisplaylines) {
		chop ($ADVline) if ($ADVline =~ /\n$/);
	}
	$ADVdisplaylines[2] += 1;
	unless (@ADVdisplaylines < 1) {
		seek(ADVDISPLAY, 0, 0);
		foreach $ADVline (@ADVdisplaylines) {
			print ADVDISPLAY ("$ADVline\n");
		}
		truncate (ADVDISPLAY, tell(ADVDISPLAY));
	}
	close (ADVDISPLAY);
	&ADVUnlockFile("$displayad.txt");
	$ADVlockerror = &ADVLockFile("$displayad.log");
	unless ($ADVlockerror) {
		if (-e "$adverts_dir/$displayad.log") {
			open (DAILYLOG,"+<$adverts_dir/$displayad.log");
		}
		else {
			open (DAILYLOG,">$adverts_dir/$displayad.log");
		}
		$ADVaccess = "$ADVmday $ADVmon $ADVyear C";
		$ADVlocation = tell DAILYLOG;
		while ($ADVline = <DAILYLOG>) {
			if (($ADVacc,$ADVlogstring) = ($ADVline =~
			  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d C)$/)) {
				if ($ADVaccess eq $ADVlogstring) {
					last;
				}
			}
			last if ($ADVaccess eq $ADVlogstring);
			$ADVlocation = tell DAILYLOG;
			$ADVacc = 0;
		}
		$ADVacc++;
		seek (DAILYLOG, $ADVlocation, 0);
		$ADVlongacc = sprintf("%010.10d",$ADVacc);
		print DAILYLOG "$ADVlongacc $ADVaccess\n";
		close (DAILYLOG);
		&ADVUnlockFile("$displayad.log");
	}
	print ("Location: $ADVdisplaylines[3]\n\n");
}

sub BadRef {
	print "Content-type: text/html\n\n";
	print "<HTML>";
	print "<HEAD><TITLE>WebAdverts Error!</TITLE></HEAD>\n";
	print "<BODY BGCOLOR=\"#ccffff\" TEXT=\"#000000\">\n";
	print "<HR><H1 ALIGN=CENTER>Invalid Destination</H1><HR>\n";
	print "<P>Sorry, but the server encountered an error ";
	print "while trying to redirect you to the destination ";
	print "of the banner on which you clicked! ";
	print "The most likely cause of the problem ";
	print "is an attempt to click on a banner ";
	print "before the graphic image has loaded. ";
	print "Another possibility is that you attempted to click ";
	print "on an old banner which was reloaded ";
	print "from your browser's cache.</P>\n";
	print "<HR></BODY></HTML>\n";
}

sub ADVLockFile {
	local($filename) = $_[0];
	local(*FILE) = $_[0];
	local($TrysLeft) = 10;
	if ((-M "$adverts_dir/$filename.lok") > .001) {
		unlink ("$adverts_dir/$filename.lok");
	}
	while ($TrysLeft--) {
		if (-f "$adverts_dir/$filename.lok") {
			select(undef,undef,undef,0.1);
		}
		else {
			open (FILE,">$adverts_dir/$filename.lok");
			if ($ADVUseLocking) {
				$lockresult = eval("flock(FILE,6)");
				if ($@) {
					$UseLocking = 0;
					last;
				}
				if (!$lockresult) {
					close (FILE);
					unlink ("$adverts_dir/$filename.lok");
					select(undef,undef,undef,0.1);
				}
				else {
					last;
				}
			}
			else {
				last;
			}
		}
	}
	if ($TrysLeft >= 0) {
		if ($ADVUseBackup) {
			if (((stat("$adverts_dir/$filename"))[7]) > 20) {
				rename ("$adverts_dir/$filename",
				  "$adverts_dir/$filename.bak");
			}
			if (((stat("$adverts_dir/$filename.bak"))[7]) > 20) {
				system ("cp $adverts_dir/$filename.bak $adverts_dir/$filename");
			}
			system ("chmod a+r $adverts_dir/$filename $adverts_dir/$filename.bak");
		}
		return 0;
	}
	else {
		return 1;
	}
}

sub ADVUnlockFile {
	local($filename) = $_[0];
	local(*FILE) = $_[0];
	close (FILE);
	unlink ("$adverts_dir/$filename.lok");
}

1;

